require "maid64"
require "Cannonball"

Player = {}

Player.new = function(x,y)
  local self = self or {}
  self.x = x
  self.y = y
  self.rot = 45
  self.speed = 0
  self.image = maid64.newImage("boat.png")
  self.image:setFilter("nearest", "nearest")
  self.cannonballs = {}

  function self.update(dt)
    if (love.keyboard.isDown("up")) then
      self.speed = 20
    else
      if (self.speed > 0) then
        self.speed = self.speed - 0.5
      else
        self.speed = 0
      end
    end
    if (love.keyboard.isDown("left")) then
      self.rot = self.rot - 100*dt
    end
    if (love.keyboard.isDown("right")) then
      self.rot = self.rot + 100*dt
    end

    if (self.rot < 0 and self.rot > 360) then
      self.rot = 0
    end

    self.x = self.x + math.cos(math.rad(self.rot))*self.speed*dt
    self.y = self.y + math.sin(math.rad(self.rot))*self.speed*dt

    -- update the cannonballs
    for i, cannonball in ipairs(self.cannonballs) do
      cannonball.update(dt)
      if (cannonball.destroy) then
        table.remove(self.cannonballs,i)
        print("DESTROYED")
      end
    end
  end

  self.draw = function()
    love.graphics.draw(self.image, self.x, self.y, math.rad(self.rot),1,1,self.image:getWidth()/2,self.image:getHeight()/2)
    for i, cannonball in ipairs(self.cannonballs) do
      cannonball:draw();
    end
  end

  self.setX = function(x)
    self.x = x
  end

  self.setY = function(y)
    self.y = y
  end

  self.setRot = function(r)
    self.rot = r
  end

  self.setSpeed = function(s)
    self.speed = s
  end

  function self.keypressed(key)
    if (key == "space") then
      cannonball = Cannonball.new(self.x+self.image:getWidth()/2, self.y+self.image:getHeight()/2, self.rot+90, math.random(30,35))
      table.insert(self.cannonballs, cannonball)
      print(#self.cannonballs)
    end
  end

  return self
end
